#!/bin/perl

# squirrelmail to CGI in 5 easy steps:
#
# 1. read the README
#
# 2. replace '/bin/perl' (above) with the full filesystem path to your
#    installation of perl
#
# 3. replace '/home/user/www/squirrelmail/' with the full filesystem path to
#    your SquirrelMail installation.

$full_path_to_squirrelmail_installation = '/home/user/www/squirrelmail/';

# 4. if necessary, replace '/usr/local/bin/php' with the full filesystem
#    path to your installation of PHP. 

$full_path_to_php = '/usr/local/bin/php';

# 5. run the script: % perl make_sm_cgi.pl
# 
# any problems?  email marriott@ackbar.org.  this is free software, released
# under the BSD license.  See README for details.

# n.b.: all of SquirrelMail's page-serving PHP scripts are in /src/.  We
# only want to CGI-enable these, since they're the "real" files getting
# executed.  You don't need a shebang line for files which are only used
# as includes.

# this script will:
# 1. rename /index.php to /index.cgi, so that it is also executed as CGI.
# 2. add a PHP shebang line to all files in /src/, and to /index.php
# 3. chmod all of the files in /src/, and /index.cgi to 0700, since that's 
#    all that's needed for CGI that the owner is executing
# 4. add an .htaccess in SM's /src/ directory, so that the files within 
#    will be executed as CGI

rename("$full_path_to_squirrelmail_installation/index.php", "$full_path_to_squirrelmail_installation/index.cgi") or die "couldn't rename /index.php to /index.cgi: $!";

@files = glob("$full_path_to_squirrelmail_installation/src/*");
push @files, "$full_path_to_squirrelmail_installation/index.cgi";

foreach $file (@files)
{
    open FILE, "< $file" or die "can't open $file: $!";
    @lines = <FILE>;
    close FILE;

    unless ($lines[0] =~ m/\#\!$full_path_to_php/)
    {
        open FILE, "> $file" or die "can't write $file: $!";
        print FILE "#!$full_path_to_php\n";
        foreach $line (@lines)
        {
            print FILE $line;
        }
        close FILE;
    }
    else
    {
        print "$file already has PHP shebang line\n";
    }
}

open HTACCESS, ">> $full_path_to_squirrelmail_installation/src/.htaccess" or die "couldn't open .htaccess: $!";
print HTACCESS "\nAddHandler cgi-script .php\n";
close HTACCESS;

chmod(0700, @files) == @files or die "couldn't chmod some of @files: $!";

# done!
